local AddOn, NS = ...
local function DUF_GetPvpIcon(factionGroup)
	if (factionGroup == "Neutral") then
		return "FFA"
	else
		return factionGroup
	end
end

------------------------------------------------------- GLOBAL FUNCTIONS -----------------------------------------

function DUF_HappinessIcon_OnEnter(self) -- Fizz Classic -- was removed from template at some stage (possibly not valid post vanilla??)
	if self.tooltip then
		GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
		GameTooltip:SetText(self.tooltip)
		if ( self.tooltipDamage ) then
			GameTooltip:AddLine(self.tooltipDamage, "", 1, 1, 1)
		end
		if ( self.tooltipLoyalty ) then
			GameTooltip:AddLine(self.tooltipLoyalty, "", 1, 1, 1)
		end
		GameTooltip:Show()
	end
end

function NS:DUF_HappinessIcon_Update() -- This is ONUPDATE.. really?!!
	if not DUF_INITIALIZED then return end
	local happiness, damagePercentage, loyaltyRate = NS.GetPetHappiness()
	local hasPetUI, isHunterPet = HasPetUI()
	if (not happiness or not isHunterPet or DUF_Settings[DUF_INDEX].pet.HappinessIcon.hide) and not DUF_OPTIONS_VISIBLE then
		DUF_PetFrame_HappinessIcon:Hide()
		return
	end
	DUF_PetFrame_HappinessIcon:SetShown(not DUF_Settings[DUF_INDEX].pet.HappinessIcon.hide)
	DUF_PetFrame_HappinessIcon:SetAlpha(DUF_Settings[DUF_INDEX].pet.HappinessIcon.alpha)
	if DUF_OPTIONS_VISIBLE then
		DUF_PetFrame_HappinessIcon_Texture:SetTexCoord(0, 0.1875, 0, 0.359375)
		return
	end

--	if not UnitName("pet") then
--		happiness = 1
--		damagePercentage = 1.25
--		loyaltyRate = 1
--	elseif not happiness or DUF_Settings[DUF_INDEX].pet.HappinessIcon.hide then
--		DUF_PetFrame_HappinessIcon:SetAlpha(0)
--		return
--	end
--	DUF_PetFrame_HappinessIcon:SetAlpha(DUF_Settings[DUF_INDEX].pet.HappinessIcon.alpha)
	if DUF_PetFrame_HappinessIcon.animatePetUnhappy then
		if happiness == 1 and DUF_PetFrame_HappinessIcon:IsShown() then
			DUF_PetFrame_HappinessIcon.AnimationGroup1:Play()
		else
			DUF_PetFrame_HappinessIcon.AnimationGroup1:Stop()
		end
	end
	if happiness == 1 then
		DUF_PetFrame_HappinessIcon_Texture:SetTexCoord(0.375, 0.5625, 0, 0.359375)
	elseif happiness == 2 then
		DUF_PetFrame_HappinessIcon_Texture:SetTexCoord(0.1875, 0.375, 0, 0.359375)
	elseif happiness == 3 then
		DUF_PetFrame_HappinessIcon_Texture:SetTexCoord(0, 0.1875, 0, 0.359375)
	end
	DUF_PetFrame_HappinessIcon.tooltip = _G["PET_HAPPINESS"..happiness]
	DUF_PetFrame_HappinessIcon.tooltipDamage = format(PET_DAMAGE_PERCENTAGE, damagePercentage)
	if loyaltyRate then
		if loyaltyRate < 0 then
			PetFrameHappiness.tooltipLoyalty = _G["LOSING_LOYALTY"]
		elseif loyaltyRate > 0 then
			PetFrameHappiness.tooltipLoyalty = _G["GAINING_LOYALTY"]
		else
			PetFrameHappiness.tooltipLoyalty = nil
		end
	end
end


function NS:DUF_LeaderIcon_Update(unit)
	if (not DUF_INITIALIZED) then return end
	if (DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].LeaderIcon.hide) then return end
	local icon = _G[DUF_FRAME_DATA[unit].frame.."_LeaderIcon"].Icon
	local inParty = GetNumGroupMembers() + GetNumSubgroupMembers()
	if (DUF_OPTIONS_VISIBLE) then
		icon:Show()
	elseif (UnitIsGroupLeader(unit) and inParty > 0) then
		icon:Show()
	else
		icon:Hide()
	end
end

function NS:DUF_LootIcon_Update(unit)
	if (not DUF_INITIALIZED) then return end
	if (DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].LootIcon.hide) then return end
	local icon = _G[DUF_FRAME_DATA[unit].frame.."_LootIcon"].Icon
	if (DUF_OPTIONS_VISIBLE) then
		icon:Show()
		return
	end
	icon:Hide()
	if (unit == "target") then return end

	local looterNum
	if (unit == "player") then
		looterNum = 0
	elseif (unit == "party1") then
		looterNum = 1
	elseif (unit == "party2") then
		looterNum = 2
	elseif (unit == "party3") then
		looterNum = 3
	elseif (unit == "party4") then
		looterNum = 4
	end

	local _, lootMaster = GetLootMethod()
	local inParty = GetNumGroupMembers() + GetNumSubgroupMembers()
	if ( lootMaster == looterNum and (inParty > 0) ) then
		icon:Show()
	end
end

function NS:DUF_PVPIcon_Update(unit)
	if (not DUF_INITIALIZED) then return end
	if (DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].PVPIcon.hide) then return end
	local icon = _G[DUF_FRAME_DATA[unit].frame.."_PVPIcon"].Icon
	icon:Show()
	local factionGroup = UnitFactionGroup(unit)
	if ( UnitIsPVPFreeForAll(unit) ) then
		icon:SetTexture("Interface\\TargetingFrame\\UI-PVP-FFA")
	elseif ( factionGroup and UnitIsPVP(unit)) then
		icon:SetTexture("Interface\\TargetingFrame\\UI-PVP-"..DUF_GetPvpIcon(factionGroup))
	elseif (DUF_OPTIONS_VISIBLE) then
			factionGroup = UnitFactionGroup("player")
			icon:SetTexture("Interface\\TargetingFrame\\UI-PVP-"..DUF_GetPvpIcon(factionGroup))
			return
	else
		icon:Hide()
	end
end

function NS:DUF_RoleIcon_Update(unit)
	if (not DUF_INITIALIZED or InCombatLockdown()) then return end -- Fizzlemizz: Comment: InCombatLockdown()  = 5.0.4 change
	local texture = _G[DUF_FRAME_DATA[unit].frame.."_RoleIcon"].Icon
	local icon = _G[DUF_FRAME_DATA[unit].frame.."_RoleIcon"]
	if (DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].RoleIcon.hide) then 
		texture:Hide()
		icon:Hide() 
		return
	end
	texture:SetTexture("Interface\\AddOns\\DiscordUnitFrames\\CustomTextures\\tank") -- Default to tank
	local role = NS.UnitGroupRolesAssigned(unit)
	if (role == "HEALER") then
		texture:SetTexture("Interface\\AddOns\\DiscordUnitFrames\\CustomTextures\\healer")
	elseif (role == "DAMAGER") then
		texture:SetTexture("Interface\\AddOns\\DiscordUnitFrames\\CustomTextures\\damage")
	end
	if not role or (role == "NONE" and not DUF_OPTIONS_VISIBLE) then
		texture:Hide()
		icon:Hide()
	else
		texture:Show()
		icon:Show()
	end
end

function NS:DUF_PhaseIcon_Update(unit)
	if not DUF_INITIALIZED or not unit then return end
	if not DUF_FRAME_DATA[unit] then
		return
	end
	local settings = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].PhaseIcon
	local icon = _G[DUF_FRAME_DATA[unit].frame.."_PhaseIcon"]
	if settings.hide then 
		return 
	end
	local phaseReason = NS.UnitPhaseReason(unit)
	if (phaseReason and UnitIsConnected(unit)) or DUF_OPTIONS_VISIBLE then
		icon:SetAlpha(1)
	else
		icon:SetAlpha(0)
	end
end

function NS:DUF_StatusIcon_Update(unit)
	if (not DUF_INITIALIZED) then return end
	if (DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].StatusIcon.hide) then return end
	local icon = _G[DUF_FRAME_DATA[unit].frame.."_StatusIcon"].Icon
	icon:Show()
	if (DUF_OPTIONS_VISIBLE) then
		icon:SetTexCoord(.5625, .9, .08, .4375)
		icon:SetTexture("Interface/CharacterFrame/UI-StateIcon")
	elseif (not UnitIsConnected(unit)) then
		icon:SetTexture("Interface/CharacterFrame/Disconnect-Icon")
		icon:SetTexCoord(0, 1, 0, 1)
	elseif (UnitHealth(unit) <= 0 or UnitIsGhost(unit)) then
		icon:SetTexture("Interface/TargetingFrame/UI-TargetingFrame-Skull")
		icon:SetTexCoord(0, 1, 0, 1)
	elseif (unit == "player" and DL_ATTACKING) then
		icon:SetTexCoord(.5625, .9, .08, .4375)
		icon:SetTexture("Interface/CharacterFrame/UI-StateIcon")
	elseif (unit == "player" and DL_INCOMBAT) then
		icon:SetTexCoord(.5625, .9, .08, .4375)
		icon:SetTexture("Interface/CharacterFrame/UI-StateIcon")
	elseif (UnitAffectingCombat(unit)) then
		icon:SetTexCoord(.5625, .9, .08, .4375)
		icon:SetTexture("Interface/CharacterFrame/UI-StateIcon")
	elseif (unit == "player" and IsResting()) then
		icon:SetTexCoord(.0625, .4375, .0625, .4375)
		icon:SetTexture("Interface/CharacterFrame/UI-StateIcon")
	else
		icon:Hide()
	end
end
